Panda3D

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
BaseParticleEmitter Class Referenceabstract
Inheritance diagram for BaseParticleEmitter:

## Public Types
enum | emissionType { ET_EXPLICIT , ET_RADIATE , ET_CUSTOM }

## Public Member Functions
virtual | ~BaseParticleEmitter ()
| destructor
void | generate (LPoint3 &pos, LVector3 &vel)
| parent generation function
PN_stdfloat | get_amplitude () const
| amplitude query
PN_stdfloat | get_amplitude_spread () const
| amplitude spread query
emissionType | get_emission_type () const
| emission type query
LVector3 | get_explicit_launch_vector () const
| query for explicit emission launch vector
LVector3 | get_offset_force () const
| user-defined force
LPoint3 | get_radiate_origin () const
| query for explicit emission launch vector
virtual BaseParticleEmitter * | make_copy ()=0
virtual void | output (std::ostream &out) const
| Write a string representation of this instance to <out>.
void | set_amplitude (PN_stdfloat a)
| amplitude assignment
void | set_amplitude_spread (PN_stdfloat as)
| amplitude spread assignment
void | set_emission_type (emissionType et)
| emission type assignment
void | set_explicit_launch_vector (const LVector3 &elv)
| assignment of explicit emission launch vector
void | set_offset_force (const LVector3 &of)
| user-defined force
void | set_radiate_origin (const LPoint3 &ro)
| assignment of radiate emission origin point
virtual void | write (std::ostream &out, int indent=0) const
| Write a string representation of this instance to <out>.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Additional Inherited Members
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

Definition at line 25 of file baseParticleEmitter.h.

## Member Enumeration Documentation

## ◆ emissionType

enum BaseParticleEmitter::emissionType

Definition at line 27 of file baseParticleEmitter.h.

## Constructor & Destructor Documentation

## ◆ ~BaseParticleEmitter()

BaseParticleEmitter::~BaseParticleEmitter | ( |  | ) |
| virtual

destructor

Definition at line 47 of file baseParticleEmitter.cxx.

## Member Function Documentation

## ◆ generate()

void BaseParticleEmitter::generate | ( | LPoint3 & | pos,
|  | LVector3 & | vel )

parent generation function

Definition at line 54 of file baseParticleEmitter.cxx.

## ◆ get_amplitude()

PN_stdfloat BaseParticleEmitter::get_amplitude | ( |  | ) | const
| inline

amplitude query

Definition at line 73 of file baseParticleEmitter.I.

## ◆ get_amplitude_spread()

PN_stdfloat BaseParticleEmitter::get_amplitude_spread | ( |  | ) | const
| inline

amplitude spread query

Definition at line 89 of file baseParticleEmitter.I.

## ◆ get_emission_type()

BaseParticleEmitter::emissionType BaseParticleEmitter::get_emission_type | ( |  | ) | const
| inline

emission type query

Definition at line 25 of file baseParticleEmitter.I.

## ◆ get_explicit_launch_vector()

LVector3 BaseParticleEmitter::get_explicit_launch_vector | ( |  | ) | const
| inline

query for explicit emission launch vector

Definition at line 41 of file baseParticleEmitter.I.

## ◆ get_offset_force()

LVector3 BaseParticleEmitter::get_offset_force | ( |  | ) | const
| inline

user-defined force

Definition at line 105 of file baseParticleEmitter.I.

## ◆ get_radiate_origin()

LPoint3 BaseParticleEmitter::get_radiate_origin | ( |  | ) | const
| inline

query for explicit emission launch vector

Definition at line 57 of file baseParticleEmitter.I.

## ◆ make_copy()

virtual BaseParticleEmitter * BaseParticleEmitter::make_copy | ( |  | ) |
| pure virtual

Implemented in ArcEmitter, BoxEmitter, DiscEmitter, LineEmitter, PointEmitter, RectangleEmitter, RingEmitter, SphereSurfaceEmitter, SphereVolumeEmitter, and TangentRingEmitter.

## ◆ output()

void BaseParticleEmitter::output | ( | std::ostream & | out | ) | const
| virtual

Write a string representation of this instance to <out>.

Reimplemented in ArcEmitter, BoxEmitter, DiscEmitter, LineEmitter, PointEmitter, RectangleEmitter, RingEmitter, SphereSurfaceEmitter, SphereVolumeEmitter, and TangentRingEmitter.

Definition at line 81 of file baseParticleEmitter.cxx.

## ◆ set_amplitude()

void BaseParticleEmitter::set_amplitude | ( | PN_stdfloat | a | ) |
| inline

amplitude assignment

Definition at line 65 of file baseParticleEmitter.I.

## ◆ set_amplitude_spread()

void BaseParticleEmitter::set_amplitude_spread | ( | PN_stdfloat | as | ) |
| inline

amplitude spread assignment

Definition at line 81 of file baseParticleEmitter.I.

## ◆ set_emission_type()

void BaseParticleEmitter::set_emission_type | ( | emissionType | et | ) |
| inline

emission type assignment

Definition at line 17 of file baseParticleEmitter.I.

## ◆ set_explicit_launch_vector()

void BaseParticleEmitter::set_explicit_launch_vector | ( | const LVector3 & | elv | ) |
| inline

assignment of explicit emission launch vector

Definition at line 33 of file baseParticleEmitter.I.

## ◆ set_offset_force()

void BaseParticleEmitter::set_offset_force | ( | const LVector3 & | of | ) |
| inline

user-defined force

Definition at line 97 of file baseParticleEmitter.I.

## ◆ set_radiate_origin()

void BaseParticleEmitter::set_radiate_origin | ( | const LPoint3 & | ro | ) |
| inline

assignment of radiate emission origin point

Definition at line 49 of file baseParticleEmitter.I.

## ◆ write()

void BaseParticleEmitter::write | ( | std::ostream & | out,
|  | int | indent = 0 ) const
| virtual

Write a string representation of this instance to <out>.

Reimplemented in ArcEmitter, BoxEmitter, DiscEmitter, LineEmitter, PointEmitter, RectangleEmitter, RingEmitter, SphereSurfaceEmitter, SphereVolumeEmitter, and TangentRingEmitter.

Definition at line 91 of file baseParticleEmitter.cxx.

References indent().

Referenced by BoxEmitter::write(), DiscEmitter::write(), LineEmitter::write(), PointEmitter::write(), RectangleEmitter::write(), RingEmitter::write(), SphereSurfaceEmitter::write(), SphereVolumeEmitter::write(), and TangentRingEmitter::write().

The documentation for this class was generated from the following files:

- panda/src/particlesystem/baseParticleEmitter.h
- panda/src/particlesystem/baseParticleEmitter.cxx
- panda/src/particlesystem/baseParticleEmitter.I